package im.creep.luabucket2;

import im.creep.luabucket2.listeners.LuaCommandPreprocessListener;
import im.creep.luabucket2.tools.LuaAssistant;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.event.Event;
import org.bukkit.event.block.Action;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * some day I will put some licence text here, but not now. //apiocera
 */
public class LuaBucketPlugin extends JavaPlugin {
    private static String logPrefix = "[LuaBucket]: ";
    private static Logger log = Logger.getLogger("Minecraft");
    private PluginDescriptionFile pdfFile;

    LuaCommandPreprocessListener luaCommandPreprocessListener;

    private EventDispatcher dispatcher = EventDispatcher.getInstance();
    private LuaManager manager = LuaManager.getInstance();

    private File dataFolder;
//    private ArrayList<LuaFunction> luaFunctions = new ArrayList<LuaFunction>();

    public void onEnable() {
        // default shit
        pdfFile = this.getDescription();
        logPrefix = "[" + pdfFile.getName() + "]: ";
        log.info(pdfFile.getName() + " version " + pdfFile.getVersion() + " is enabled!");

        // creating a configuration directory if it doesn't exist yet
        dataFolder = new File(getDataFolder().getAbsolutePath());
        if (!dataFolder.exists()) {
            if (!dataFolder.mkdir()) {
                log.severe(logPrefix + "config directory not present and unable to be made. No operations follow.");
                return;
            }
        }

        luaCommandPreprocessListener = new LuaCommandPreprocessListener();
        this.getServer().getPluginManager().registerEvent(Event.Type.PLAYER_COMMAND_PREPROCESS, luaCommandPreprocessListener, Event.Priority.Highest, this);

        dispatcher.setPlugin(this);
        runLua();
    }

    public void onDisable() {
        log.info(logPrefix + "is disabled!");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args) {
        if (cmd.getName().equalsIgnoreCase("luareload")) {
            if (!sender.isOp()){
                sender.sendMessage("You have to be an op to restart Lua.");
            } else {
                runLua();
            }
            return true;
        }
        return false;
    }


    private void runLua() {
        manager.reset();
        dispatcher.reset();

        manager.addGlobal("dispatcher", dispatcher);
        manager.addGlobal("assistant", new LuaAssistant());
        for (Event.Type ev : Event.Type.values()) {
            manager.addGlobal("MC_EVENT_" + ev.toString(), ev); // this is the most sane way to push Java enums into Lua
        }

        for (Action ac : Action.values()) {
            manager.addGlobal("MC_ACTION_" + ac.toString(), ac);
        }

        for (Material m : Material.values()) {
            manager.addGlobal("MC_MATERIAL_" + m.toString(), m);
        }

        for (ChatColor cc : ChatColor.values()) {
            manager.addGlobal("MC_CHATCOLOR_" + cc.toString(), cc);
        }

        for (File f : getSnipList()) {
            log.log(Level.INFO, logPrefix + "loading snip " + f.getName());
            manager.runSnip(f);
        }
    }

    private void stopLua(){
        dispatcher.reset();
        manager.reset();
    }

    private List<File> getSnipList() {
        List<File> snips = new ArrayList<File>();
        File[] children = dataFolder.listFiles();
        if (children != null) {
            for (File f : children) {
                if (f.getName().endsWith(".lua")) snips.add(f);
            }
        }
        return snips;
    }
}
